(*
    Copyright (C) 2012 Christophe Calvès

    This file is part of WC.

    WC is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    WC is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
*)



type ibs = Int    of int
         | Bool   of bool
         | String of string



type ('a,'b) term = AVar      of 'a
                  | ADat      of 'b
                  | AFun      of 'a list * ('a,'b) term
                  | AApp      of ('a,'b) term * ('a,'b) term list
                  | ALetIn    of ('a * ('a,'b) term) list * ('a,'b) term
                  | ALetRecIn of 'a * ('a,'b) term * ('a,'b) term
                  | ASeq      of ('a,'b) term list
                  | AIf       of ('a,'b) term * ('a,'b) term * ('a,'b) term


type ('a,'b) ast = AAst of (string * int) list * ('a,'b) term
