(*
    Copyright (C) 2012 Christophe Calvès

    This file is part of WC.

    WC is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    WC is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
*)


(*************************
 *                       *
 *         Either        *
 *                       *
 *************************)


type ('a , 'b) either = Left of  'a
                      | Right of 'b
let left x  = Left x
let right x = Right x
let either f g = function
 | Left x  -> f x
 | Right y -> g y

let ereturn y = Right y
let ebind x f = match x with
  | Left x  -> Left x
  | Right y -> f y

let eerror  x = Left  x
let ecatch m h = match m with
 | Left x  -> h x
 | Right y -> Right y

